include:
  - template: Code-Quality.gitlab-ci.yml
  - template: Jobs/SAST.gitlab-ci.yml
  - template: Jobs/Secret-Detection.gitlab-ci.yml
  - template: Security/Dependency-Scanning.gitlab-ci.yml


.composer:
  image: php:8.2-cli
  before_script:
    - apt-get update
    - apt-get install zip unzip git -yqq
    - pecl install xdebug && docker-php-ext-enable xdebug
    - php -r "copy('https://getcomposer.org/installer', 'composer-setup.php');"
    - php composer-setup.php
    - php -r "unlink('composer-setup.php');"
    - php composer.phar install


stages:
  - build
  - code quality
  - container scanning
  - test
  - deploy

variables:
  CONTAINER_IMAGE: "${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_NAME}"
  REGISTRY_CONTAINER_PATH: /public/citoyens/idelibre

build:
  stage: build
  script:
    - echo "Building the application"


code_quality:
  tags:
    - cq-sans-dind


test:
  stage: test
  extends:
    - .composer
  variables:
    XDEBUG_MODE: coverage
  script:
    - php composer.phar test-coverage
  artifacts:
    paths:
      - coverage
    expire_in: 1h

deploy:
  stage: deploy
  script:
    - echo "Deploying the application"
